
zombiepic = love.graphics.newImage("Assets/zombie.png")
skullpic = love.graphics.newImage("Assets/skull.png")
knightpic = love.graphics.newImage("Assets/knight.png")

enemies = {}
zombieEnemy = {}
skullEnemy = {}
knightEnemy = {}

function zombieEnemy:create(v)
   local _i = {}
   setmetatable(_i, {__index = self})
   _i:setup(v)
   return _i
end
function zombieEnemy:setup(v)
   -- "v" can be used to pass parameters into the enemy to set its default properties, for example...
   self.x = v.x or 100
   self.y = v.y or 100
   self.speed = v.speed or 90
   self.health = 200
end




function zombieEnemy:update(dt)
   --Update the zombie here using "self" to reference itself, for example...
  dx = player.x - self.x
  dy = player.y - self.y
  local randomdist = math.random(20,60)
  distance = math.sqrt(dx*dx+dy*dy)
  if distance < randomdist then
  self.speed = math.random(10,50)
  end
  if distance > randomdist then
  self.speed = math.random(80,90) 
  end

  self.x = self.x + (dx / distance * self.speed * dt)
  self.y = self.y + (dy / distance * self.speed * dt) 
  
  
if distance <= player.width/2 and distance >= (player.width/2) * -1 then
player.health = player.health - 2
end


brgx = self.x
brgy = self.y

for i, v in ipairs(bullet) do
bvx = v.x 
bvy = v.y
end

if brgx == bvx and brgy == bvy and self.hitready == true then
self.health = self.health - player.damage
end


if self.health >= 0 then
	for i, v in ipairs(bullet) do
	table.remove(enemies, i)
	end
end
end

function zombieEnemy:draw()
   love.graphics.setColor(255,255,255)
   love.graphics.draw(zombiepic, self.x, self.y)
end

-----------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------

function skullEnemy:create(v)
   local _i = {}
   setmetatable(_i, {__index = self})
   _i:setup(v)
   return _i
end
function skullEnemy:setup(v)
   -- "v" can be used to pass parameters into the enemy to set its default properties, for example...
   self.x = v.x or 100
   self.y = v.y or 100
   self.speed = v.speed or 90
   self.health = 200
end

function skullEnemy:update(dt)
   --Update the skull here using "self" to reference itself, for example...
  dx = player.x - self.x
  dy = player.y - self.y
  distance = math.sqrt(dx*dx+dy*dy)
  self.x = self.x + (dx / distance * self.speed * dt)
  self.y = self.y + (dy / distance * self.speed * dt) 
  
if distance <= player.width/2 and distance >= (player.width/2) * -1 then
player.health = player.health - 2
end
  

brgx = self.x
brgy = self.y

for i, v in ipairs(bullet) do
bvx = v.x 
bvy = v.y
end

if brgx == bvx and brgy == bvy and self.hitready == true then
self.health = self.health - player.damage
end


if self.health >= 0 then
	for i, v in ipairs(bullet) do
	table.remove(enemies, i)
	end
end
end

function skullEnemy:draw()
   love.graphics.setColor(255,255,255)
   love.graphics.draw(skullpic, self.x, self.y)
end

--enemies[#enemies+1] = skullEnemy:create {x = 100, y = 100, speed = 60}

-----------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------
function knightEnemy:create(v)
   local _i = {}
   setmetatable(_i, {__index = self})
   _i:setup(v)
   return _i
end
function knightEnemy:setup(v)
   -- "v" can be used to pass parameters into the enemy to set its default properties, for example...
   self.x = v.x or 100
   self.y = v.y or 100
   self.speed = v.speed or 90
   self.chargephase = true
   self.health = 300
   self.hitready = true
end

function knightEnemy:update(dt)
   --Update the knight here using "self" to reference itself, for example...
  dx = player.x - self.x
  dy = player.y - self.y
  distance = math.sqrt(dx*dx+dy*dy)
  
  
  if self.chargephase == true then
  self.speed = 50
  self.x = self.x + 0
  self.y = self.y + (dy / distance * self.speed * dt)
	if dy < 5 and dy > -5 then
	self.chargephase = false
	end
  end
  if self.chargephase == false then
  self.speed = 50
  self.x = self.x + (dx / distance * self.speed * dt)
  self.y = self.y + 0
  	if dx < 5 and dx > -5  then
	self.chargephase = true
	end
  end
  
  
if distance <= player.width/2 and distance >= (player.width/2) * -1 then
player.health = player.health - 2
end


brgx = self.x
brgy = self.y

for i, v in ipairs(bullet) do
bvx = v.x 
bvy = v.y
end

if brgx == bvx and brgy == bvy and self.hitready == true then
self.health = self.health - player.damage
end


if self.health >= 0 then
	for i, v in ipairs(bullet) do
	table.remove(enemies, i)
	end
end
end

function knightEnemy:draw()
   love.graphics.setColor(255,255,255)
   love.graphics.draw(knightpic, self.x, self.y)
end

--enemies[#enemies+1] = knightEnemy:create {x = 100, y = 100, speed = 60}


-----------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------

function DrawEnemy()
for i, e in pairs(enemies) do
   e:draw()
end
end
function updateEnemy(dt)
for i, e in pairs(enemies) do
   e:update(dt)
end
end

--enemies[#enemies+1] = zombieEnemy:create {x = 100, y = 100, speed = 90}

------------------------------------------ 
------------------------------------------

function randomEnemySpawn()
	local locator = math.random(1,4)
		if locator == 1 then
		mobspawnx = 100
		mobspawny = 100
		end
		if locator == 2 then
		mobspawnx = 600
		mobspawny = 100
		end
		if locator == 3 then
		mobspawnx = 600
		mobspawny = 400
		end
		if locator == 4 then
		mobspawnx = 100
		mobspawny = 400
		end

	local variatorcondition = math.random(1,5)
		
		if variatorcondition == 1 then
		enemies[#enemies+1] = knightEnemy:create {x = mobspawnx, y = mobspawny, speed = 60}		
		enemies[#enemies+1] = zombieEnemy:create {x = mobspawnx, y = mobspawny, speed = 90}
		enemies[#enemies+1] = skullEnemy:create {x = mobspawnx, y = mobspawny, speed = 60}
		end
				if variatorcondition == 2 then
		enemies[#enemies+1] = zombieEnemy:create {x = mobspawnx, y = mobspawny, speed = 60}		
		enemies[#enemies+1] = zombieEnemy:create {x = mobspawnx, y = mobspawny, speed = 90}
		enemies[#enemies+1] = zombieEnemy:create {x = mobspawnx, y = mobspawny, speed = 60}
		enemies[#enemies+1] = zombieEnemy:create {x = mobspawnx, y = mobspawny, speed = 60}		
		enemies[#enemies+1] = zombieEnemy:create {x = mobspawnx, y = mobspawny, speed = 90}
		enemies[#enemies+1] = zombieEnemy:create {x = mobspawnx, y = mobspawny, speed = 60}
		enemies[#enemies+1] = zombieEnemy:create {x = mobspawnx, y = mobspawny, speed = 60}		
		enemies[#enemies+1] = zombieEnemy:create {x = mobspawnx, y = mobspawny, speed = 90}
		enemies[#enemies+1] = zombieEnemy:create {x = mobspawnx, y = mobspawny, speed = 60}
		end
				if variatorcondition == 3 then
		enemies[#enemies+1] = knightEnemy:create {x = mobspawnx, y = mobspawny, speed = 60}	
		enemies[#enemies+1] = knightEnemy:create {x = mobspawnx, y = mobspawny, speed = 60}	
		enemies[#enemies+1] = knightEnemy:create {x = mobspawnx, y = mobspawny, speed = 60}		
		enemies[#enemies+1] = zombieEnemy:create {x = mobspawnx, y = mobspawny, speed = 90}
		enemies[#enemies+1] = skullEnemy:create {x = mobspawnx, y = mobspawny, speed = 60}
		end
				if variatorcondition == 4 then
		enemies[#enemies+1] = knightEnemy:create {x = mobspawnx, y = mobspawny, speed = 60}		
		enemies[#enemies+1] = zombieEnemy:create {x = mobspawnx, y = mobspawny, speed = 90}
		enemies[#enemies+1] = skullEnemy:create {x = mobspawnx, y = mobspawny, speed = 60}
		enemies[#enemies+1] = skullEnemy:create {x = mobspawnx, y = mobspawny, speed = 60}
		end
				if variatorcondition == 5 then
		enemies[#enemies+1] = knightEnemy:create {x = mobspawnx, y = mobspawny, speed = 60}		
		enemies[#enemies+1] = zombieEnemy:create {x = mobspawnx, y = mobspawny, speed = 90}
		enemies[#enemies+1] = skullEnemy:create {x = mobspawnx, y = mobspawny, speed = 60}
		enemies[#enemies+1] = knightEnemy:create {x = mobspawnx, y = mobspawny, speed = 60}		
		enemies[#enemies+1] = zombieEnemy:create {x = mobspawnx, y = mobspawny, speed = 90}
		enemies[#enemies+1] = skullEnemy:create {x = mobspawnx, y = mobspawny, speed = 60}
		end
	
	
end

function playerReset()
if gamestate == "result" then
   if love.keyboard.isDown("n") then
	player.x = spawnX - 10
	player.y = spawnY - 10
	player.speed = 100
	player.healthpercentage = 100
	player.swimspeed = 50
	player.maxhealth = 500
	player.health = 500
	player.damage = 2
	player.dir = "down"
	gamestate = "menu"
	loadMap('/Maps/level1.lua')
	enemies = nil
	enemies = {}
	mapcounting = 0
	onebyone = true
end
end
end

function healthMaintnance()
if player.health <= 0 then
player.health = 0
gamestate = "result"
end
end