---Table for Map Makery
  local quadInfo = {
  { " ", 0,  0 }, -- 1 -- Basic Floor
  { "A", 20, 0 }, -- 2 -- Water Top Left
  { "B", 40, 0 },-- 3 -- Water Top Mid
  { "C", 60, 0 }, -- 4 -- Water Top Right
  { "g", 80, 0 }, -- 5 -- Gutter
  { "x", 0,  20 }, -- 6 -- Wall
  { "D", 20, 20 }, -- 7 -- Water Mid Left
  { "E", 40, 20 }, -- 8 -- Water Mid Mid (No Edges)
  { "F", 60, 20 }, -- 9 -- Water Mid Right
  { "b", 80, 20 }, -- 10 -- Block
  { "O", 0,  40 }, -- 11 -- Spawn Tile
  { "G", 20, 40 }, -- 12 -- Water Bot Left
  { "H", 40, 40 }, -- 13 -- Water Bot Mid
  { "I", 60, 40 }, -- 14 -- Water Bot Right
  { "n", 80, 40 }, -- 15 -- Rust Floor
  { "-", 0,  60 }, -- 16 -- Blackitude
  { "X", 20, 60 }, -- 17 -- Left Exit
  { "Y", 40, 60 }, -- 18 -- Top Exit
  { "Z", 60, 60 }, -- 19 -- Right Exit
  { "W", 80, 60 }, -- 20 -- Bottom Exit
  { "0", 0,  80 }, -- 16 -- Rug
  { "1", 20, 80 }, -- 17 -- Shag Rug (Right)
  { "3", 40, 80 }, -- 18 -- Shag Rug (Top)
  { "5", 60, 80 }, -- 19 -- Shag Rug (Bot)
  { "7", 80, 80 }, -- 20 -- Shag Tug (Right)
  { "q", 0,  100 }, -- 16 -- Meh
  { "2", 20, 100 }, -- 17 -- Shag Rug 2(Right)
  { "4", 40, 100 }, -- 18 -- Shag Rug 2(Top)
  { "6", 60, 100 }, -- 19 -- Shag Rug 2(Bot)
  { "8", 80, 100 }, -- 20 -- Shag Tug 2(Right)
  { "u", 0,  120 }, -- 16 -- Meh
  { "@", 20, 120 }, -- 17 -- Spawn Bot Left
  { "#", 40, 120 }, -- 18 -- Spawn Bot Right
  { "$", 60, 120 }, -- 19 -- Spawn Top Left
  { "%", 80, 120 }, -- 20 -- Spawn Top Right
  
  }
  
local tileString = [[
------------------------------
xxxxxxxxxxxxxYYxxxxxxxxxxxxxxx
x            00             bx
x            56              x
x                     AC     x
x                     GI     x
x     b                      x
x                            x
x                            x
X01          $%  AC        70Z
X02          @#  GI        80Z
x                            x
x     AC          bbbbb      x
x     GI                     x
x                            x
x            34              x
x bbbbbbb    00              x
xxxxxxxxxxxxxWWxxxxxxxxxxxxxxx
------------------------------
------------------------------
]]

mapcounting = mapcounting + 1
randomEnemySpawn()
newMap(20,20,'Assets/Tileset.png',quadInfo,tileString)